/*
 * File:        uart.h
 * Description: 
 * Rev:         A
 * Created:     1997/12/12
 * $Author$
 * mail:        kingdon@ptgrey.com
 *
 * Copyright Point Grey Research 1997
 * Vancouver B.C.
 *
 * The copyright to the computer program(s) herein
 * is the property of Point Grey Research Inc.
 * The program(s) may be used and/or copied only with
 * the written permission of Point Grey Research
 * or in accordance with the terms and conditions
 * stipulated in the agreement/contract under which
 * the program(s) have been supplied.
 *
 * $Id$
 */

#ifndef _UART_INCLUDED_
#define _UART_INCLUDED_

#ifdef __cplusplus
extern "C" {
#endif

#define UART_DRIVER_TABLE_ENTRY \
  { uart_initialize, uart_open, uart_close, \
    uart_read, uart_write, uart_control }

rtems_device_driver uart_initialize(
  rtems_device_major_number,
  rtems_device_minor_number,
  void *
);

rtems_device_driver uart_open(
  rtems_device_major_number,
  rtems_device_minor_number,
  void *
);

rtems_device_driver uart_close(
  rtems_device_major_number,
  rtems_device_minor_number,
  void *
);

rtems_device_driver uart_read(
  rtems_device_major_number,
  rtems_device_minor_number,
  void *
);

rtems_device_driver uart_write(
  rtems_device_major_number,
  rtems_device_minor_number,
  void *
);

rtems_device_driver uart_control(
  rtems_device_major_number,
  rtems_device_minor_number,
  void *
);

/* low-level (semi-private) interface... */
void   _uart_flush( unsigned chan );
int    _uart_write( unsigned chan, const char* buf, int maxlen );
int    _uart_read( unsigned chan, char* buf, int maxlen, int term_chr );
rtems_status_code  _uart_init( unsigned chan, long baud, unsigned level );

#ifdef __cplusplus
}
#endif

#endif

